Index: dlls/kernel/dosmem.c
===================================================================
RCS file: /home/wine/wine/dlls/kernel/dosmem.c,v
retrieving revision 1.7
diff -u -r1.7 dosmem.c
--- dlls/kernel/dosmem.c	14 Jun 2004 17:04:35 -0000	1.7
+++ dlls/kernel/dosmem.c	2 Aug 2004 17:02:28 -0000
@@ -57,19 +57,21 @@
 #define DM_BLOCK_DEBUG		0xABE00000
 #define DM_BLOCK_TERMINAL	0x00000001
 #define DM_BLOCK_FREE		0x00000002
-#define DM_BLOCK_MASK		0x001FFFFC
+#define DM_BLOCK_MASK		0x001FFFF0
+
 
-/*
 #define __DOSMEM_DEBUG__
- */
+
 
 typedef struct {
    unsigned	size;
+   char		pad[12];
 } dosmem_entry;
 
 typedef struct {
   unsigned      blocks;
   unsigned      free;
+  char		pad[8];
 } dosmem_info;
 
@@ -148,9 +151,13 @@
  */
 static dosmem_entry *DOSMEM_RootBlock(void)
 {
+   dosmem_entry *dm;
     /* first block has to be paragraph-aligned */
-    return (dosmem_entry*)(((char*)DOSMEM_InfoBlock()) +
-                           ((((sizeof(dosmem_info) + 0xf) & ~0xf) - sizeof(dosmem_entry))));
+//   dm = (dosmem_entry*) ((((DWORD)(DOSMEM_InfoBlock()) + 31) >> 4) << 4);
+   dm = (dosmem_entry*)(((char*)DOSMEM_InfoBlock()) +
+                           ((((sizeof(dosmem_info) + 0xf) & ~0xf) - sizeof(dosmem_entry))) + 16);
+   TRACE ("dm=0x%08x\n", dm);
+   return dm;
 }
 
 /***********************************************************************
@@ -425,6 +432,8 @@
    dosmem_entry *prev = NULL;
 #endif
 
+   TRACE ("size=0x%06x bytes available=0x%06x bytes\n", size, DOSMEM_Available());
+   
    if( size > info_block->free ) return NULL;
    dm = DOSMEM_RootBlock();
 
@@ -433,10 +442,9 @@
 #ifdef __DOSMEM_DEBUG__
        if( (dm->size & DM_BLOCK_DEBUG) != DM_BLOCK_DEBUG )
        {
-	    WARN("MCB overrun! [prev = 0x%08x]\n", 4 + (UINT)prev);
+	    WARN("MCB overrun! [prev = 0x%08x]\n", 4 + (UINT)dm);
 	    return NULL;
        }
-       prev = dm;
 #endif
        if( dm->size & DM_BLOCK_FREE )
        {
@@ -459,7 +467,7 @@
 		    * paragraph-aligned (and dm loses free bit) */
 
 	           dm->size = (((size + 0xf + sizeof(dosmem_entry)) & ~0xf) -
-			         	      sizeof(dosmem_entry));
+			         	      sizeof(dosmem_entry)) + 16;
 	           next = (dosmem_entry*)(((char*)dm) +
 	 		   sizeof(dosmem_entry) + dm->size);
 	           next->size = (blocksize - (dm->size +
@@ -571,11 +583,23 @@
         */
 
        dm->size = (((size + 0xf + sizeof(dosmem_entry)) & ~0xf) -
-                   sizeof(dosmem_entry));
+                   sizeof(dosmem_entry)) + 16;
        next = (dosmem_entry*)(((char*)dm) +
                               sizeof(dosmem_entry) + dm->size);
-       next->size = (blocksize - (dm->size +
-                                  sizeof(dosmem_entry))) | DM_BLOCK_FREE;
+	           next->size = (blocksize - (dm->size +
+			   sizeof(dosmem_entry))) | DM_BLOCK_FREE
+#ifdef __DOSMEM_DEBUG__
+					          | DM_BLOCK_DEBUG
+#endif
+						  ;
+   
+#ifdef __DOSMEM_DEBUG__
+               dm->size |= DM_BLOCK_DEBUG;
+#endif
    } 
    else 
    {
@@ -587,6 +611,7 @@
     */
    info_block->free += orgsize - dm->size;
 
+   TRACE ("size=0x%06x bytes available=0x%06x bytes\n", size, DOSMEM_Available());
    return size;
 }
 
@@ -602,13 +627,13 @@
 
    while (dm && dm->size != DM_BLOCK_TERMINAL)
    {
+   TRACE ("dm=0x%08x size=0x%08x\n", dm, dm->size);
 #ifdef __DOSMEM_DEBUG__
        if( (dm->size & DM_BLOCK_DEBUG) != DM_BLOCK_DEBUG )
        {
-	    WARN("MCB overrun! [prev = 0x%08x]\n", 4 + (UINT)prev);
+	    WARN("MCB overrun! [prev = 0x%08x]\n", (UINT)dm);
 	    return NULL;
        }
-       prev = dm;
 #endif
        if( dm->size & DM_BLOCK_FREE )
        {
